Skip to main content
Signature
<ais-range-input
  attribute="string"
  // Optional parameters
  :min="number"
  :max="number"
  :precision="number"
  :class-names="object"
/>

Import

To ensure optimal bundle sizes, see Optimize build size.
Vue
import { AisRangeInput } from "vue-instantsearch";
// Use "vue-instantsearch/vue3/es" for Vue 3

export default {
  components: {
    AisRangeInput
  },
  // ...
};

See this widget in action

Preview this widget and its behavior.

About this widget

The ais-range-input widget allows a user to select a numeric range using a minimum and maximum input.

Requirements

The attribute provided to the widget must be in attributes for faceting, either on the dashboard or using the attributesForFaceting parameter with the API. The values of the attribute must be numbers, not strings.

Examples

Vue
<ais-range-input attribute="price" />

Props

attribute
string
required
The name of the attribute in the record.
Vue
<ais-range-input attribute="price" />
min
number
The minimum value for the input. When not provided, the minimum value is automatically computed by Algolia from the data in the index.
Vue
<ais-range-input
  [...]
  :min="10"
/>
max
number
The maximum value for the input. When not provided, the maximum value is automatically computed by Algolia from the data in the index.
Vue
<ais-range-input
  [...]
  :max="500"
/>
precision
number
default:0
The number of digits after the decimal point to use.
Vue
<ais-range-input
  [...]
  :precision="2"
/>
class-names
object
default:"{}"
The CSS classes you can override:
  • ais-RangeInput. The root of the widget.
  • ais-RangeInput--noRefinement. The root of the widget without refinement.
  • ais-RangeInput-form. The form wrapper around the inputs and the submit button.
  • ais-RangeInput-separator. The separator between the min and the max.
  • ais-RangeInput-button. The button that triggers the submission of the form.
  • ais-RangeInput-label. The enclosing label of an input.
  • ais-RangeInput-input. The inputs.
  • ais-RangeInput-input--min. The input for the minimum value.
  • ais-RangeInput-input--max. The input for the maximum value.
Vue
<ais-range-input
  [...]
  :class-names="{
    'ais-RangeInput': 'MyCustomRangeInput',
    'ais-RangeInput-form': 'MyCustomRangeInputForm',
    // ...
  }"
/>

Customize the UI

default
The slot to override the complete DOM output of the widget.When you implement this slot, none of the other slots will change the output, as the default slot surrounds them.Scope
  • currentRefinement: { min: number, max: number }. A value that contains the currently applied refinement.
  • range: { min: number, max: number }. A value that contains the minimum and maximum available value.
  • canRefine: boolean. Whether the refinement can be applied.
  • refine: ({ min: number, max: number }) => void. A function to select the refinement.
  • sendEvent: (eventType: 'click', facetValue: string) => void. The function to send click events.
    • The view event is automatically sent when the facets are rendered.
    • The click event is automatically sent when refine is called.
    To learn more, see the insights middleware.
Vue
<template>
  <!-- ... -->
  <ais-range-input attribute="price">
    <template
      v-slot="{ currentRefinement, range, canRefine, refine, sendEvent }"
    >
      <input
        type="number"
        :min="range.min"
        :max="range.max"
        :placeholder="range.min"
        :disabled="!canRefine"
        :value="formatMinValue(currentRefinement.min, range.min)"
        @input="
          refine({
            min: $event.currentTarget.value,
            max: formatMaxValue(currentRefinement.max, range.max),
          })
        "
      />
      →
      <input
        type="number"
        :min="range.min"
        :max="range.max"
        :placeholder="range.max"
        :disabled="!canRefine"
        :value="formatMaxValue(currentRefinement.max, range.max)"
        @input="
          refine({
            min: formatMinValue(currentRefinement.min, range.min),
            max: $event.currentTarget.value,
          })
        "
      />
    </template>
  </ais-range-input>
</template>

<script>
export default {
  methods: {
    formatMinValue(minValue, minRange) {
      return minValue !== null && minValue !== minRange ? minValue : "";
    },
    formatMaxValue(maxValue, maxRange) {
      return maxValue !== null && maxValue !== maxRange ? maxValue : "";
    },
  },
};
</script>
minLabel
The slot to override the DOM output for the label of the minimum value.
Vue
<ais-range-input attribute="price">
  <template v-slot:minLabel>Minimum:</template>
</ais-range-input>
maxLabel
The slot to override the DOM output for the label of the maximum value.
Vue
<ais-range-input attribute="price">
  <template v-slot:maxLabel>Maximum:</template>
</ais-range-input>
submitLabel
The slot to override the DOM output for the label of the submit button.
Vue
<ais-range-input attribute="price">
  <template v-slot:submitLabel>Submit</template>
</ais-range-input>
separator
The slot to override the DOM output for the separator beteween the inputs.
Vue
<ais-range-input attribute="price">
  <template v-slot:separator>→</template>
</ais-range-input>

HTML output

HTML
<div class="ais-RangeInput">
  <form class="ais-RangeInput-form">
    <label class="ais-RangeInput-label">
      <input
        class="ais-RangeInput-input ais-RangeInput-input--min"
        type="number"
        placeholder=""
        step="1"
      />
    </label>
    <span class="ais-RangeInput-separator">to</span>
    <label class="ais-RangeInput-label">
      <input
        class="ais-RangeInput-input ais-RangeInput-input--max"
        type="number"
        placeholder=""
        step="1"
      />
    </label>
    <button class="ais-RangeInput-submit" type="submit">
      Go
    </button>
  </form>
</div>
Last modified on May 19, 2026

Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
Signature
<RangeInput
  attribute={string}
  // Optional parameters
  min={number}
  max={number}
  precision={number}
  classNames={object}
  translations={object}
  ...props={ComponentProps<'div'>}
/>

Import

JavaScript
import { RangeInput } from "react-instantsearch";

See this widget in action

Preview this widget and its behavior.

About this widget

<RangeInput> is a widget to let users select a numeric range using minimum and maximum inputs.
You can also create your own UI with useRange.

Requirements

The attribute provided to the widget must be in attributes for faceting, either on the dashboard or using the attributesForFaceting parameter with the API. The values of the attribute must be numbers, not strings.

Examples

JavaScript
import React from "react";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import { InstantSearch, RangeInput } from "react-instantsearch";

const searchClient = algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey");

function App() {
  return (
    <InstantSearch indexName="instant_search" searchClient={searchClient}>
      <RangeInput attribute="price" />
    </InstantSearch>
  );
}

Props

attribute
string
required
The name of the attribute in the .
JavaScript
<RangeInput attribute="price" />;
min
number
The minimum value for the input. When not provided, the minimum value is automatically computed by Algolia from the data in the index.
JavaScript
<RangeInput
  // ...
  min={10}
/>;
max
number
The maximum value for the input. When not provided, the maximum value is automatically computed by Algolia from the data in the .
JavaScript
<RangeInput
  // ...
  max={500}
/>;
precision
number
default:0
The number of digits to use after the decimal point.
JavaScript
<RangeInput
  // ...
  precision={2}
/>;
classNames
Partial<RangeInputClassNames>
The CSS classes you can override and pass to the widget’s elements. It’s useful to style widgets with class-based CSS frameworks like Bootstrap or Tailwind CSS.
  • root. The root element of the widget.
  • noRefinementRoot. The root element when there are no refinements.
  • form. The form element.
  • label. Each label element.
  • input. Each input element.
  • inputMin. The minimum input element.
  • inputMax. The maximum input element.
  • separator. The separator element between inputs.
  • submit. The submit button.
JavaScript
<RangeInput
  // ...
  classNames={{
    root: "MyCustomRangeInput",
    form: "MyCustomRangeInputForm MyCustomRangeInputForm--subclass",
  }}
/>;
translations
Partial<RangeInputTranslations>
A mapping of keys to translation values.
  • separatorElementText. The text for the separator element between the minimum and maximum inputs.
  • submitButtonText. The text for the submit button.
JavaScript
<RangeInput
  // ...
  translations={{
    separatorElementText: "-",
    submitButtonText: "Apply",
  }}
/>;
...props
React.ComponentProps<'div'>
Any <div> prop to forward to the root element of the widget.
JavaScript
<RangeInput
  // ...
  className="MyCustomRangeInput"
  title="My custom title"
/>;

Hook

React InstantSearch let you create your own UI for the <RangeInput> widget with useRange. Hooks provide APIs to access the widget state and interact with InstantSearch. The useRange Hook accepts parameters and returns APIs. It must be used inside the <InstantSearch> component.

Usage

First, create your React component:
JavaScript
import { useRange } from "react-instantsearch";

function CustomRangeInput(props) {
  const { start, range, canRefine, refine, sendEvent } = useRange(props);

  return <>{/* Your JSX */}</>;
}
Then, render the widget:
JavaScript
<CustomRangeInput {...props} />

Parameters

Hooks accept parameters. You can either pass them manually or forward props from a custom component.
When passing functions to Hooks, ensure stable references to prevent unnecessary re-renders. Use useCallback() for memoization. Arrays and objects are automatically memoized.
attribute
string
required
The name of the attribute in the records.
JavaScript
const rangeApi = useRange({
  attribute: "price",
});
min
number
The minimum value for the input. When not provided, the minimum value is automatically computed by Algolia from the data in the index.
JavaScript
const rangeApi = useRange({
  // ...
  min: 10,
});
max
number
The maximum value for the input. When not provided, the maximum value is automatically computed by Algolia from the data in the index.
JavaScript
const rangeApi = useRange({
  // ...
  max: 500,
});
precision
number
default:0
The number of digits to use after the decimal point.
JavaScript
const rangeApi = useRange({
  // ...
  precision: 2,
});

APIs

Hooks return APIs, such as state and functions. You can use them to build your UI and interact with React InstantSearch.
start
RangeBoundaries
The current value for the refinement, with start[0] as the minimum value and start[1] as the maximum value.
TypeScript
type RangeBoundaries = [number | undefined, number | undefined];
range
Range
The current available value for the range.
TypeScript
type Range = {
  min: number | undefined;
  max: number | undefined;
};
canRefine
boolean
Whether users can refine further.
refine
(rangeValue: RangeBoundaries) => void
Sets a range to filter the results on. Both values are optional, and default to the higher and lower bounds. You can use undefined to remove a previously set bound or to set an infinite bound.
JavaScript
const { refine } = useRange(props);

// ...

const onRangeSubmit = (min, max) => {
  refine([
    Number.isFinite(min) ? min : undefined,
    Number.isFinite(max) ? max : undefined,
  ]);
};
sendEvent
(eventType: string, facetValue: string, eventName?: string) => void
Sends an event to the Insights middleware.

Example

import React, { useState } from "react";
import { useRange } from "react-instantsearch";

const unsetNumberInputValue = "";

function CustomRangeInput(props) {
  const { start, range, canRefine, refine } = useRange(props);
  const step = 1 / Math.pow(10, props.precision || 0);
  const values = {
    min:
      start[0] !== -Infinity && start[0] !== range.min
        ? start[0]
        : unsetNumberInputValue,
    max:
      start[1] !== Infinity && start[1] !== range.max
        ? start[1]
        : unsetNumberInputValue,
  };
  const [prevValues, setPrevValues] = useState(values);

  const [{ from, to }, setRange] = useState({
    from: values.min?.toString(),
    to: values.max?.toString(),
  });

  if (values.min !== prevValues.min || values.max !== prevValues.max) {
    setRange({ from: values.min?.toString(), to: values.max?.toString() });
    setPrevValues(values);
  }

  return (
    <form
      onSubmit={(event) => {
        event.preventDefault();

        refine([from ? Number(from) : undefined, to ? Number(to) : undefined]);
      }}
    >
      <label>
        <input
          type="number"
          min={range.min}
          max={range.max}
          value={stripLeadingZeroFromInput(from || unsetNumberInputValue)}
          step={step}
          placeholder={range.min?.toString()}
          disabled={!canRefine}
          onInput={({ currentTarget }) => {
            const value = currentTarget.value;

            setRange({ from: value || unsetNumberInputValue, to });
          }}
        />
      </label>
      <span>to</span>
      <label>
        <input
          type="number"
          min={range.min}
          max={range.max}
          value={stripLeadingZeroFromInput(to || unsetNumberInputValue)}
          step={step}
          placeholder={range.max?.toString()}
          disabled={!canRefine}
          onInput={({ currentTarget }) => {
            const value = currentTarget.value;

            setRange({ from, to: value || unsetNumberInputValue });
          }}
        />
      </label>
      <button type="submit">Go</button>
    </form>
  );
}

function stripLeadingZeroFromInput(value) {
  return value.replace(/^(0+)\d/, (part) => Number(part).toString());
}
Last modified on May 7, 2026

UI libraries / Angular InstantSearch / Widgets
Signature
<ais-range-input
  attribute="string"

  // Optional parameters
  [min]="number"
  [max]="number"
  [precision]="number"
  currency="string"
  separator="string"
  submitLabel="string"
></ais-range-input>
Import
1
2
3
4
5
6
7
8
import { NgAisRangeInputModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisRangeInputModule,
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-range-input allows a user to select a numeric range using a minimum and maximum input.

Requirements

The attributes passed to the attributes prop must be declared as Attributes for faceting on the Algolia dashboard) or configured as attributesForFaceting with the Algolia API.

Examples

1
<ais-range-input attribute="price"></ais-range-input>

Props

attribute
type: string
Required

The name of the attribute in the record.

1
<ais-range-input attribute="price"></ais-range-input>
min
type: number
Optional

The minimum value for the input. When not provided, the minimum value is automatically computed by Algolia from the data in the index.

1
2
3
4
<ais-range-input
  // ...
  [min]="10"
></ais-range-input>
max
type: number
Optional

The maximum value for the input. When not provided, the maximum value is automatically computed by Algolia from the data in the index.

1
2
3
4
<ais-range-input
  // ...
  [max]="500"
></ais-range-input>
precision
type: number
default: 2
Optional

The number of digits after the decimal point to use.

1
2
3
4
<ais-range-input
  // ...
  [precision]="0"
></ais-range-input>
currency
type: string
default: $
Optional

Label for the currency sign.

1
2
3
4
<ais-range-input
  // ...
  currency="€"
></ais-range-input>
separator
type: string
default: to
Optional

Label for the separator between the inputs.

1
2
3
4
<ais-range-input
  // ...
  separator="→"
></ais-range-input>
submitLabel
type: string
default: Go
Optional

Label of the submit button.

1
2
3
4
<ais-range-input
  // ...
  submitLabel="Ok"
></ais-range-input>

HTML output

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
<div class="ais-RangeInput">
  <form class="ais-RangeInput-form">
    <label class="ais-RangeInput-label">
      <input
        class="ais-RangeInput-input ais-RangeInput-input--min"
        type="number"
        placeholder=""
        step="1"
      />
    </label>
    <span class="ais-RangeInput-separator">to</span>
    <label class="ais-RangeInput-label">
      <input
        class="ais-RangeInput-input ais-RangeInput-input--max"
        type="number"
        placeholder=""
        step="1"
      />
    </label>
    <button class="ais-RangeInput-submit" type="submit">Go</button>
  </form>
</div>

Customize the UI with connectRange

If you want to create your own UI of the ais-range-input widget, you can combine the connectRange connector with the TypedBaseWidget class.

This connector is also used to build other widgets: RangeSlider

1. Extend the TypedBaseWidget class

First of all, you will need to write some boilerplate code to initialize correctly the TypedBaseWidget class. This happens in the constructor() of your class extending the TypedBaseWidget class.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

@Component({
  selector: 'app-range-input',
  template: '<p>It works!</p>'
})
export class RangeInput extends TypedBaseWidget {
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('RangeInput');
  }
}

There are a couple of things happening in this boilerplate:

  • create a RangeInput class extending TypedBaseWidget
  • reference the <ais-instantsearch> parent component instance on the RangeInput widget class
  • set app-range-input as a selector, so we can use our component as <app-range-input></app-range-input>

2. Connect your custom widget

The TypedBaseWidget class has a method called createWidget() which takes two arguments: the connector to use and an object of options (instance options) for this connector. We call this method at ngOnInit. This component now implements OnInit.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectRange, {
  RangeWidgetDescription,
  RangeConnectorParams
} from 'instantsearch.js/es/connectors/range/connectRange';

@Component({
  selector: 'app-range-input',
  template: '<p>It works!</p>'
})
export class RangeInput extends TypedBaseWidget<RangeWidgetDescription, RangeConnectorParams> {
  public state: RangeWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('RangeInput');
  }
  ngOnInit() {
    this.createWidget(connectRange, {
      // instance options
      attribute: 'price',
    });
    super.ngOnInit();
  }
}

3. Render from the state

Your component instance has access to a this.state property which holds the rendering options of the widget.

public state: RangeWidgetDescription['renderState'];
// {
//   start: number[];
//   range: object;
//   refine: Function;
//   widgetParams: object;
// }
1
2
3
4
5
6
7
<div *ngIf="state.range">
  from
  <input type="number" #min [value]="state.start[0]" min="state.range.min" max="state.range.max" />
  to
  <input type="number" #max [value]="state.start[1]" min="state.range.min" max="state.range.max" />
  <button (click)="state.refine([min.value, max.value])">Go</button>
</div>

Rendering options

start
type: number[]

The current value for the refinement, with start[0] as the minimum value and start[1] as the maximum value.

range
type: object

The current available value for the range.

refine
type: function

Sets a range to filter the results on. Both values are optional, and default to the higher and lower bounds. You can use undefined to remove a previously set bound or to set an infinite bound.

widgetParams
type: object

All original widget options forwarded to the render function.

Instance options

attribute
type: string
Required

The name of the attribute in the record.

min
type: number
Optional

The minimum value for the input. When not provided, the minimum value is automatically computed by Algolia from the data in the index.

max
type: number
Optional

The maximum value for the input. When not provided, the maximum value is automatically computed by Algolia from the data in the index.

precision
type: number
default: 0
Optional

The number of digits after the decimal point to use.

Full example

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectRange, {
  RangeWidgetDescription,
  RangeConnectorParams
} from 'instantsearch.js/es/connectors/range/connectRange';

@Component({
  selector: 'app-range-input',
  template: `
<div *ngIf="state.range">
  from
  <input type="number" #min [value]="state.start[0]" min="state.range.min" max="state.range.max" />
  to
  <input type="number" #max [value]="state.start[1]" min="state.range.min" max="state.range.max" />
  <button (click)="state.refine([min.value, max.value])">Go</button>
</div>
`
})
export class RangeInput extends TypedBaseWidget<RangeWidgetDescription, RangeConnectorParams> {
  public state: RangeWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('RangeInput');
  }
  ngOnInit() {
    this.createWidget(connectRange, {
      // instance options
      attribute: 'price',
    });
    super.ngOnInit();
  }
}
Did you find this page helpful?